@echo off

REM Remember current working directory
set "orig_dir=%cd%"
REM Run tool and store output to log file
set "log_file=%orig_dir%\update_log.txt"

echo ----- Debug information ----- >> "%log_file%"
rem Append the date and time to the file
echo Date: %date% >> "%log_file%"
echo Time: %time% >> "%log_file%"
rem Append the computer name and user name to the file
echo Computer name: %computername% >> "%log_file%"
echo User name: %username% >> "%log_file%"
rem Append the operating system and version to the file
echo OS: %os% >> "%log_file%"
echo Version: %ver% >> "%log_file%"
rem Append the current working directory to the file
echo Current directory: %cd% >> "%log_file%"
rem Append the list of environment variables to the file
echo Environment variables: >> "%log_file%"
set >> "%log_file%"

REM Check that PATH argument was provided
if "%1" == "" (
  echo Usage: %0 PATH
  exit /b 1
)

REM Check that PATH exists and is a directory
if not exist "%1\its" (
  echo Error: %1 is not a directory >> "%log_file%"
  exit /b 1
)

REM Change directory to PATH
cd /d "%1\its" || (
  echo Error: unable to change directory to %1 >> "%log_file%"
  exit /b 1
)

setlocal enabledelayedexpansion
set binfiles=..\*.hex

set args=
for %%f in ("%binfiles%") do (
    set args=!args! "%%~ff"
)

if not "%args%" == "" (
    Windows_Studio_ITS.exe /hide %args% /s /log

    set exitCode=!errorlevel!
    if !errorlevel! equ 0 (
      echo %date% %time% - UPDATE OK >> "%log_file%"
    ) else (
      echo %date% %time% - UPDATE FAILED, error: !errorlevel! >> "%log_file%"
    )
) else (
  echo %date% %time% - UPDATE FAILED - NO HEX FILES WERE FOUND >> "%log_file%"
)

REM Change back to original directory
cd /d "%orig_dir%"

echo exiting with exit code: %exitCode% >> "%log_file%"
REM return the exit code at the end of the script
exit /b %exitCode%