#!/bin/sh
# update firmware using SIS toolkit

# Remember current working directory
orig_dir=$(pwd)

# Check that PATH argument was provided
if [ $# -ne 1 ]; then
  echo "Usage: $0 [PATH]" >&2
  exit 1
fi

# Check that PATH exists and is a directory
if [ ! -d "$1/tools" ]; then
  echo "Error: $1 is not a directory" >> "$orig_dir/update_log.txt"
  exit 1
fi

# Change directory to PATH
if ! cd "$1/tools"; then
  echo "Error: unable to change directory to $1/tools" >> "$orig_dir/update_log.txt"
  exit 1
fi

echo "---------------- SelfExtract Update started. $(date)" >> "$orig_dir/update_log.txt"
echo "os: $(cat /etc/os-release)" >> "$orig_dir/update_log.txt"
echo "kernel: $(uname -a)" >> "$orig_dir/update_log.txt"

cur_pwd=$(pwd)
# Add current directory to LD_LIBRARY_PATH
export LD_LIBRARY_PATH="$cur_pwd:$LD_LIBRARY_PATH"

# Run tool and store output to log file
if ./nUpdateFW -ba ../*.bin >> "$orig_dir/update_log.txt" 2>&1; then
  echo "$(date) - UPDATE OK" >> "$orig_dir/update_log.txt"
else
  echo "$(date) - UPDATE FAILED" >> "$orig_dir/update_log.txt"
  exit 2
fi
